/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.List;

/**
 *
 * @author johneisenmann
 */
public class InventoryDatabase {
    
    private static String path = App.rootPath + "data/inventories/";
    
    public static InventoryDatabase database = new InventoryDatabase();
    
    public Inventory loadInventory(int accountId) {
        Inventory output = new Inventory(accountId);
        File tempFile = getInventoryFile(accountId);
        if (!tempFile.exists()) {
            return output;
        }
        try {
            FileInputStream tempStream = new FileInputStream(tempFile);
            BufferedReader tempReader = new BufferedReader(new InputStreamReader(tempStream));
            boolean shouldWriteArmor = false;
            boolean shouldWriteItems = false;
            while (true) {
                String tempLine = tempReader.readLine();
                if (tempLine == null) {
                    break;
                }
                if (tempLine.length() > 0) {
                    String[] tempList = tempLine.split(",");
                    String tempCommand = tempList[0];
                    if (tempCommand.equals("armor")) {
                        shouldWriteArmor = true;
                        shouldWriteItems = false;
                    } else if (tempCommand.equals("items")) {
                        shouldWriteArmor = false;
                        shouldWriteItems = true;
                    } else {
                        InventoryItem tempInventoryItem = convertTextListToInventoryItem(tempList);
                        if (shouldWriteArmor) {
                            output.setArmor(tempInventoryItem);
                        }
                        if (shouldWriteItems) {
                            output.addInventoryItem(tempInventoryItem);
                        }
                    }
                }
            }
            tempReader.close();
        } catch (IOException exception) {
            System.out.println("Unable to access file.");
        }
        return output;
    }
    
    public void saveInventory(Inventory inventory) {
        File tempFile = getInventoryFile(inventory.getAccountId());
        try {
            FileOutputStream tempStream = new FileOutputStream(tempFile);
            BufferedWriter tempWriter = new BufferedWriter(new OutputStreamWriter(tempStream));
            tempWriter.write("armor\n");
            tempWriter.write(convertInventoryItemToText(inventory.getArmor()));
            tempWriter.write("items\n");
            List<InventoryItem> tempInventoryItemList = inventory.getInventoryItemList();
            int index = 0;
            while (index < tempInventoryItemList.size()) {
                InventoryItem tempInventoryItem = tempInventoryItemList.get(index);
                tempWriter.write(convertInventoryItemToText(tempInventoryItem));
                index += 1;
            }
            tempWriter.close();
        } catch (IOException exception) {
            System.out.println("Unable to access file.");
        }
    }
    
    private String convertInventoryItemToText(InventoryItem inventoryItem) {
        if (inventoryItem == null) {
            return "";
        }
        return inventoryItem.getId() + ","
                + inventoryItem.getBlockId() + ","
                + inventoryItem.getBlockData() + ","
                + inventoryItem.getQuantity() + "\n";
    }
    
    private InventoryItem convertTextListToInventoryItem(String[] tempTextList) {
        int tempId = Integer.parseInt(tempTextList[0]);
        int tempBlockId = Integer.parseInt(tempTextList[1]);
        int tempBlockData = Integer.parseInt(tempTextList[2]);
        int tempQuantity = Integer.parseInt(tempTextList[3]);
        return new InventoryItem(tempId, tempBlockId, tempBlockData, tempQuantity);
    }
    
    private File getInventoryFile(int accountId) {
        File tempDirectory = new File(path);
        if (!tempDirectory.exists()) {
            tempDirectory.mkdir();
        }
        String tempName = accountId + ".txt";
        String tempPath = path + "/" + tempName;
        return new File(tempPath);
    }
    
}
