package com.mycompany.ostracraft;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.List;

import com.mycompany.ostracraft.entities.Player;

public class PlayerDatabase {

	private static String path = App.rootPath + "data/players/";
    
    public static PlayerDatabase database = new PlayerDatabase();
    
    public Player loadPlayer(int accountId) {
    	Pos tempPos = new Pos(0, 0, 2);
        double tempHealth = 100.0;
    	Account tempAccount = AccountDatabase.database.getAccountById(accountId);
        File tempFile = getPlayerFile(accountId);
        if (!tempFile.exists()) {
            return new Player(tempPos, tempAccount);
        }
        try {
            FileInputStream tempStream = new FileInputStream(tempFile);
            BufferedReader tempReader = new BufferedReader(new InputStreamReader(tempStream));
            while (true) {
                String tempLine = tempReader.readLine();
                if (tempLine == null) {
                    break;
                }
                if (tempLine.length() > 0) {
                    String[] tempList = tempLine.split(",");
                    String tempCommand = tempList[0];
                    if (tempCommand.equals("pos")) {
                    	int tempPosX = Integer.parseInt(StringEncoder.encoder.decode(tempList[1]));
                    	int tempPosY = Integer.parseInt(StringEncoder.encoder.decode(tempList[2]));
                    	int tempPosZ = Integer.parseInt(StringEncoder.encoder.decode(tempList[3]));
                    	tempPos = new Pos(tempPosX, tempPosY, tempPosZ);
                    } else if (tempCommand.equals("health")) {
                    	tempHealth = Double.parseDouble(StringEncoder.encoder.decode(tempList[1]));
                    }
                }
            }
            tempReader.close();
        } catch (IOException exception) {
            System.out.println("Unable to access file.");
        }
        Player output = new Player(tempPos, tempAccount);
        output.setHealth(tempHealth);
        return output;
    }
    
    public void savePlayer(Player player) {
    	File tempFile = getPlayerFile(player.getAccount().getId());
        try {
            FileOutputStream tempStream = new FileOutputStream(tempFile);
            BufferedWriter tempWriter = new BufferedWriter(new OutputStreamWriter(tempStream));
            Pos tempPos = player.getPos();
            StringBuilder tempBuilder = new StringBuilder();
            tempBuilder.append("pos,");
            tempBuilder.append(StringEncoder.encoder.encode(Integer.toString(tempPos.getX())) + ",");
            tempBuilder.append(StringEncoder.encoder.encode(Integer.toString(tempPos.getY())) + ",");
            tempBuilder.append(StringEncoder.encoder.encode(Integer.toString(tempPos.getZ())) + "\n");
            tempWriter.write(tempBuilder.toString());
            tempBuilder = new StringBuilder();
            tempBuilder.append("health,");
            tempBuilder.append(StringEncoder.encoder.encode(Double.toString(player.getHealth())) + "\n");
            tempWriter.write(tempBuilder.toString());
            tempWriter.close();
        } catch (IOException exception) {
            System.out.println("Unable to access file.");
        }
        InventoryDatabase.database.saveInventory(player.getInventory());
    }
    
    private File getPlayerFile(int accountId) {
        File tempDirectory = new File(path);
        if (!tempDirectory.exists()) {
            tempDirectory.mkdir();
        }
        String tempName = accountId + ".txt";
        String tempPath = path + "/" + tempName;
        return new File(tempPath);
    }
	
}
