/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft;

/**
 *
 * @author Jack
 */
public class Pos {
    
    private int x;
    private int y;
    private int z;
    
    public Pos(int x, int y, int z) {
        this.x = x;
        this.y = y;
        this.z = z;
    }
    
    public int getX() {
        return x;
    }
    
    public void setX(int x) {
        this.x = x;
    }
    
    public int getY() {
        return y;
    }
    
    public void setY(int y) {
        this.y = y;
    }
    
    public int getZ() {
        return z;
    }
    
    public void setZ(int z) {
        this.z = z;
    }
    
    public Pos copy() {
        return new Pos(x, y, z);
    }
    
    public void set(Pos pos) {
        x = pos.x;
        y = pos.y;
        z = pos.z;
    }
    
    public void add(Pos pos) {
        x += pos.x;
        y += pos.y;
        z += pos.z;
    }
    
    public void subtract(Pos pos) {
        x -= pos.x;
        y -= pos.y;
        z -= pos.z;
    }
    
    public int getSquareDistance(Pos pos) {
        int tempOffsetX = x - pos.getX();
        int tempOffsetY = y - pos.getY();
        int tempOffsetZ = z - pos.getZ();
        return tempOffsetX * tempOffsetX + tempOffsetY * tempOffsetY + tempOffsetZ * tempOffsetZ;
    }
    
    public int getOrthogonalDistance(Pos pos) {
    	int tempOffsetX = Math.abs(x - pos.getX());
    	int tempOffsetY = Math.abs(y - pos.getY());
    	int tempOffsetZ = Math.abs(z - pos.getZ());
    	if (tempOffsetX > tempOffsetY && tempOffsetX > tempOffsetZ) {
    		return tempOffsetX;
    	} else if (tempOffsetY > tempOffsetZ) {
    		return tempOffsetY;
    	} else {
    		return tempOffsetZ;
    	}
    }
    
    @Override
    public int hashCode() {
        return (x - 2048) + ((y - 2048) << 12) + ((-z) << 24);
    }
    
    @Override
    public boolean equals(Object object) {
        if (object == null) {
            return false;
        }
        if (!(object instanceof Pos)) {
            return false;
        }
        Pos tempPos = (Pos)object;
        return (x == tempPos.getX() && y == tempPos.getY() && z == tempPos.getZ());
    }
    
    public String toString() {
        return "(" + x + " " + y + " " + z + ")";
    }
    
}
