/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Jack
 */
public class SettingsDatabase {
    
    private static String path = App.rootPath + "data/settings.txt";
    
    public static String currentVersion = "1.0";
    public static SettingsDatabase database = new SettingsDatabase();
    
    private File file;
    private List<Setting> settingsList;
    
    public SettingsDatabase() {
        file = new File(path);
        if (!file.exists()) {
            settingsList = new ArrayList<Setting>();
            settingsList.add(new Setting("version", currentVersion));
            settingsList.add(new Setting("seed", Long.toString((new Random()).nextLong())));
            saveSettingsList();
        } else {
            loadSettingsList();
        }
    }
    
    public void loadSettingsList() {
        settingsList = new ArrayList<Setting>();
        try {
            FileInputStream tempStream = new FileInputStream(file);
            BufferedReader tempReader = new BufferedReader(new InputStreamReader(tempStream));
            while (true) {
                String tempLine = tempReader.readLine();
                if (tempLine == null) {
                    break;
                }
                String[] tempList = tempLine.split(",");
                if (tempList.length == 2) {
                    String tempName = StringEncoder.encoder.decode(tempList[0]);
                    String tempValue = StringEncoder.encoder.decode(tempList[1]);
                    settingsList.add(new Setting(tempName, tempValue));
                }
            }
            tempReader.close();
        } catch (IOException exception) {
            System.out.println("Unable to access file.");
        }
    }
    
    public void saveSettingsList() {
        try {
            FileOutputStream tempStream = new FileOutputStream(file);
            BufferedWriter tempWriter = new BufferedWriter(new OutputStreamWriter(tempStream));
            int index = 0;
            while (index < settingsList.size()) {
                Setting tempSetting = settingsList.get(index);
                StringBuilder tempBuilder = new StringBuilder();
                tempBuilder.append(StringEncoder.encoder.encode(tempSetting.getName()));
                tempBuilder.append(",");
                tempBuilder.append(StringEncoder.encoder.encode(tempSetting.getValue()));
                tempBuilder.append("\n");
                tempWriter.write(tempBuilder.toString());
                index += 1;
            }
            tempWriter.close();
        } catch (IOException exception) {
            System.out.println("Unable to access file.");
        }
    }
    
    private Setting getSetting(String name) {
        int index = 0;
        while (index < settingsList.size()) {
            Setting tempSetting = settingsList.get(index);
            if (tempSetting.getName().equals(name)) {
                return tempSetting;
            }
            index += 1;
        }
        return null;
    }
    
    public String getSettingValue(String name) {
        Setting tempSetting = getSetting(name);
        return tempSetting.getValue();
    }
    
    public void setSettingValue(String name, String value) {
        Setting tempSetting = getSetting(name);
        if (tempSetting == null) {
            settingsList.add(new Setting(name, value));
        } else {
            tempSetting.setValue(value);
        }
        saveSettingsList();
    }
    
}
