/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.blocks;

import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.BlockTypeQuantityPair;
import com.mycompany.ostracraft.InventoryItem;
import com.mycompany.ostracraft.Pos;
import com.mycompany.ostracraft.World;
import com.mycompany.ostracraft.entities.Entity;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Jack
 */
public abstract class AbstractBlock implements BlockType {

    public boolean getIsPhantom(Entity entity) {
        return true;
    }

    public boolean getEmitsLight() {
        return false;
    }
    
    public double getBaseMiningTime() {
        return 1.0;
    }
    
    public double getMiningTime(BlockType blockType) {
        if (blockType != null) {
            if (blockType instanceof Tool) {
                Tool tool = (Tool)blockType;
                return getBaseMiningTime() / tool.getEfficiency();
            }
        }
        return getBaseMiningTime();
    }

    public boolean canMineBlock(InventoryItem inventoryItem) {
        return true;
    }

    public List<BlockTypeQuantityPair> getProducts(Pos pos, InventoryItem inventoryItem) {
        List<BlockTypeQuantityPair> output = new ArrayList<BlockTypeQuantityPair>();
        output.add(new BlockTypeQuantityPair(this, 1));
        return output;
    }
    
    public boolean damageInventoryItem(InventoryItem inventoryItem) {
        if (inventoryItem != null) {
            if (inventoryItem.getBlockType() instanceof Tool) {
                inventoryItem.setBlockData(inventoryItem.getBlockData() + 1);
                return true;
            }
        }
        return false;
    }
    
    public boolean shouldRemoveFromInventory(int blockData) {
        return false;
    }
    
    public boolean isStackable() {
        return true;
    }
    
    public void interact(Pos pos) {
        // Do nothing.
    }
    
    public void performSpawnAction(Pos pos) {
        // Do nothing.
    }
    
    public void respondToExplosion(Pos pos) {
        App.world.setBlockType(pos, Air.blockType, World.ChunkGenerationMode.DONT_GENERATE);
    }
    
    public void randomTick(Pos pos) {
        // Do nothing.
    }
    
}
