/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.blocks;

import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.Pos;
import com.mycompany.ostracraft.World;
import signals.ElectronicSignal;

/**
 *
 * @author Jack
 */
public abstract class ElectronicInput extends ElectronicBlock {

    @Override
    public boolean canAcceptChannel(Pos pos) {
        return true;
    }

    @Override
    public boolean canAcceptInput(Pos pos) {
        return false;
    }

    @Override
    public boolean canAcceptOutput(Pos pos) {
        return false;
    }
    
    @Override
    public boolean canAcceptModule(Pos pos) {
        return false;
    }
    
    public ElectronicSignal.ElectronicMessage getMessage(Pos pos) {
        return null;
    }
    
    @Override
    public void processSignal(ElectronicSignal signal) {
        Pos tempPos = signal.getPos();
        boolean tempValue = getElectronicValue(tempPos);
        signal.propogateInput(tempValue, getMessage(tempPos));
    }
    
    @Override
    public boolean getElectronicValue(Pos pos) {
        Pos tempPos = new Pos(0, 0, 0);
        int index = 0;
        while (index < World.electronicSignalOffsetSet.length) {
            tempPos.set(pos);
            Pos tempOffset = World.electronicSignalOffsetSet[index];
            tempPos.add(tempOffset);
            BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.DONT_GENERATE);
            if (tempBlockType instanceof ElectronicChannel) {
                ElectronicChannel tempElectronicChannel = (ElectronicChannel)tempBlockType;
                return tempElectronicChannel.getElectronicValue(tempPos);
            }
            index += 1;
        }
        return false;
    }
    
}
