/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.blocks;

import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.Pos;
import com.mycompany.ostracraft.World;
import signals.ElectronicSignal;

/**
 *
 * @author Jack
 */
public abstract class ElectronicOutput extends ElectronicBlock {
    
    @Override
    public void performSpawnAction(Pos pos) {
        boolean tempValue = getElectronicValue(pos);
        int index = 0;
        while (index < World.electronicSignalOffsetSet.length) {
            Pos tempPos = pos.copy();
            Pos tempOffset = World.electronicSignalOffsetSet[index];
            tempPos.add(tempOffset);
            BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.DONT_GENERATE);
            if (tempBlockType instanceof ElectronicBlock) {
                ElectronicBlock tempElectronicBlock = (ElectronicBlock)tempBlockType;
                if (tempElectronicBlock.canAcceptOutput(tempPos)) {
                    App.world.addSignal(new ElectronicSignal(tempPos, tempValue));
                }
            }
            index += 1;
        }
    }
    
    @Override
    public boolean getElectronicValue(Pos pos) {
        Pos tempPos = new Pos(0, 0, 0);
        int index = 0;
        while (index < World.electronicSignalOffsetSet.length) {
            tempPos.set(pos);
            Pos tempOffset = World.electronicSignalOffsetSet[index];
            tempPos.add(tempOffset);
            BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.DONT_GENERATE);
            if (tempBlockType instanceof ElectronicInput || tempBlockType instanceof ElectronicModule) {
                ElectronicBlock tempElectronicBlock = (ElectronicBlock)tempBlockType;
                return tempElectronicBlock.getElectronicValue(tempPos);
            }
            index += 1;
        }
        return false;
    }
    
    @Override
    public boolean canAcceptChannel(Pos pos) {
        return false;
    }

    @Override
    public boolean canAcceptInput(Pos pos) {
        return true;
    }

    @Override
    public boolean canAcceptOutput(Pos pos) {
        return false;
    }
    
    @Override
    public boolean canAcceptModule(Pos pos) {
        return true;
    }
    
}
