/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.blocks;

import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.BlockTypeQuantityPair;
import com.mycompany.ostracraft.InventoryItem;
import com.mycompany.ostracraft.Pos;
import com.mycompany.ostracraft.World;
import com.mycompany.ostracraft.entities.Entity;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Jack
 */
public class Grass extends AbstractBlock {
    
    public static BlockType blockType = new Grass();
    
    private static Random random = new Random();
    
    public int getId() {
        return 2;
    }
    
    @Override
    public boolean getIsPhantom(Entity entity) {
        return false;
    }

    @Override
    public List<BlockTypeQuantityPair> getProducts(Pos pos, InventoryItem inventoryItem) {
        List<BlockTypeQuantityPair> output = new ArrayList<BlockTypeQuantityPair>();
        output.add(new BlockTypeQuantityPair(Dirt.blockType, 1));
        return output;
    }
    
    @Override
    public void randomTick(Pos pos) {
        if (random.nextInt(10) == 1) {
            Pos tempPos = pos.copy();
            tempPos.setZ(tempPos.getZ() + 1);
            boolean tempLighting = App.world.getIsLightOrAboveGround(tempPos, World.ChunkGenerationMode.DONT_GENERATE);
            if (!tempLighting) {
                App.world.setBlockType(pos, Dirt.blockType, World.ChunkGenerationMode.DONT_GENERATE);
                return;
            }
            BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.DONT_GENERATE);
            if (tempBlockType != null) {
                if (!tempBlockType.getIsPhantom(null)
                        && tempBlockType.getId() != LoadingBlock.blockType.getId()) {
                    App.world.setBlockType(pos, Dirt.blockType, World.ChunkGenerationMode.DONT_GENERATE);
                }
            }
        }
    }
}
