/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.blocks;

import com.mycompany.ostracraft.BlockTypeQuantityPair;
import com.mycompany.ostracraft.InventoryItem;
import com.mycompany.ostracraft.Pos;
import com.mycompany.ostracraft.entities.Entity;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Jack
 */
public class Stone extends AbstractBlock {
    
    public static BlockType blockType = new Stone();
    
    private static Random random = new Random();
    
    public int getId() {
        return 9;
    }
    
    @Override
    public boolean getIsPhantom(Entity entity) {
        return false;
    }
    
    @Override
    public List<BlockTypeQuantityPair> getProducts(Pos pos, InventoryItem inventoryItem) {
        List<BlockTypeQuantityPair> output = new ArrayList<BlockTypeQuantityPair>();
        if (inventoryItem == null) {
            return output;
        }
        if (!(inventoryItem.getBlockType() instanceof Tool)) {
            return output;
        }
        int tempRange = 100 - Math.abs(pos.getZ()) * 2;
        if (tempRange < 50) {
            tempRange = 50;
        }
        int tempNumber = random.nextInt(tempRange);
        if (tempNumber >= 0 && tempNumber < 2) {
            output.add(new BlockTypeQuantityPair(Diamond.blockType, 1));
        } else if (tempNumber >= 10 && tempNumber < 17) {
            output.add(new BlockTypeQuantityPair(Iron.blockType, 1));
        } else if (tempNumber >= 20 && tempNumber < 27) {
            output.add(new BlockTypeQuantityPair(Coal.blockType, 1));
        } else if (tempNumber >= 30 && tempNumber < 37) {
            output.add(new BlockTypeQuantityPair(Silicon.blockType, 1));
        } else {
            output.add(new BlockTypeQuantityPair(MinedStone.blockType, 1));
        }
        return output;
    }
    
    @Override
    public double getBaseMiningTime() {
        return 5.0;
    }
}
