/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.blocks;

import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.Pos;
import com.mycompany.ostracraft.World;
import signals.ElectronicSignal;

/**
 *
 * @author Jack
 */
public class Switch extends ElectronicChannel {
    
    public static BlockType blockType = new Switch();
    
    public int getId() {
        return 30;
    }
    
    @Override
    public void interact(Pos pos) {
        App.world.setBlockType(pos, SwitchActive.blockType, World.ChunkGenerationMode.GENERATE_ENABLED);
    }
    
    @Override
    public void performSpawnAction(Pos pos) {
        int index = 0;
        while (index < World.electronicSignalOffsetSet.length) {
            Pos tempPos = pos.copy();
            Pos tempOffset = World.electronicSignalOffsetSet[index];
            tempPos.add(tempOffset);
            BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.DONT_GENERATE);
            if (tempBlockType instanceof ElectronicBlock) {
                ElectronicBlock tempElectronicBlock = (ElectronicBlock)tempBlockType;
                if (tempElectronicBlock.canAcceptChannel(tempPos)) {
                    App.world.addSignal(new ElectronicSignal(tempPos, false));
                }
            }
            index += 1;
        }
    }
    
    @Override
    public boolean getElectronicValue(Pos pos) {
        return false;
    }

    @Override
    public boolean canAcceptChannel(Pos pos) {
        return false;
    }

    @Override
    public boolean canAcceptInput(Pos pos) {
        return false;
    }

    @Override
    public boolean canAcceptOutput(Pos pos) {
        return false;
    }
    
    @Override
    public void processSignal(ElectronicSignal signal) {
        // Do nothing.
    }
    
}
