/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.entities;

import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.Pos;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Jack
 */
public class CannonFace extends FallingEntity {
    
    private static int visibilityRange = 8;
    
    private int walkDelay = 0;
    private int fireDelay = 0;
    
    public CannonFace(Pos pos) {
        super(pos);
    }
    
    @Override
    public int getTypeId() {
        return 5;
    }
    
    @Override
    public void tick() {
        super.tick();
        
        if (walkDelay <= 0) {
            Pos tempPos = getPos().copy();
            tempPos.setX(tempPos.getX() - visibilityRange);
            tempPos.setY(tempPos.getY() - visibilityRange);
            List<Entity> tempEntityList = (List<Entity>)(List<?>)App.world.getPlayersInRegion(tempPos, visibilityRange * 2 + 1, 1);
            if (tempEntityList.size() > 0) {
                Entity tempEntity = getClosestEntity(tempEntityList);
                Pos tempPos2 = tempEntity.getPos();
                int tempPosX = tempPos2.getX();
                int tempPosY = tempPos2.getY();
                int tempPosZ = tempPos2.getZ();
                List<Pos> tempPosList = new ArrayList<Pos>();
                tempPosList.add(new Pos(tempPosX - 3, tempPosY, tempPosZ));
                tempPosList.add(new Pos(tempPosX + 3, tempPosY, tempPosZ));
                tempPosList.add(new Pos(tempPosX, tempPosY - 3, tempPosZ));
                tempPosList.add(new Pos(tempPosX, tempPosY + 3, tempPosZ));
                Pos tempPos3 = getClosestPos(tempPosList);
                if (getPos().equals(tempPos3)) {
                    fireBulletTowardPos(tempPos2);
                } else {
                    walkTowardPos(tempPos3, 0);
                }
            } else {
                if (getRandom().nextInt(4) == 1) {
                    walkRandomly();
                }
            }
            walkDelay = 4;
        } else {
            walkDelay -= 1;
        }
        if (fireDelay > 0) {
            fireDelay -= 1;
        }
        
    }
    
    private void fireBulletTowardPos(Pos pos) {
        Pos tempPos = pos.copy();
        tempPos.subtract(getPos());
        int tempDistanceX = Math.abs(tempPos.getX());
        int tempDistanceY = Math.abs(tempPos.getY());
        if (tempDistanceX > tempDistanceY) {
            if (tempPos.getX() > 0) {
                fireBulletWithOffset(new Pos(1, 0, 0));
            } else {
                fireBulletWithOffset(new Pos(-1, 0, 0));
            }
        } else {
            if (tempPos.getY() > 0) {
                fireBulletWithOffset(new Pos(0, 1, 0));
            } else {
                fireBulletWithOffset(new Pos(0, -1, 0));
            }
        }
    }
    
    private void fireBulletWithOffset(Pos offset) {
        if (fireDelay > 0) {
            return;
        }
        fireDelay = 15;
        Pos tempPos = getPos().copy();
        tempPos.add(offset);
        App.world.addEntity(new BulletEntity(tempPos, offset));
    }
    
}
