/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.entities;

import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.Pos;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Jack
 */
public class SadFace extends FallingEntity {
    
    private static int visibilityRange = 8;
    private static int teleportRange = 100;
    
    private int walkDelay = 0;
    
    public SadFace(Pos pos) {
        super(pos);
    }
    
    @Override
    public int getTypeId() {
        return 7;
    }
    
    @Override
    public void tick() {
        super.tick();
        
        if (walkDelay <= 0) {
            Pos tempPos = getPos().copy();
            tempPos.setX(tempPos.getX() - visibilityRange);
            tempPos.setY(tempPos.getY() - visibilityRange);
            List<Entity> tempEntityList = (List<Entity>)(List<?>)App.world.getPlayersInRegion(tempPos, visibilityRange * 2 + 1, 1);
            if (tempEntityList.size() > 0) {
                Entity tempEntity = getClosestEntity(tempEntityList);
                walkTowardPos(tempEntity.getPos(), 1);
            } else {
                if (getRandom().nextInt(4) == 1) {
                    walkRandomly();
                }
            }
            walkDelay = 5;
        } else {
            walkDelay -= 1;
        }
        
        teleportPlayerAtOffset(new Pos(-1, 0, 0));
        teleportPlayerAtOffset(new Pos(1, 0, 0));
        teleportPlayerAtOffset(new Pos(0, -1, 0));
        teleportPlayerAtOffset(new Pos(0, 1, 0));
        teleportPlayerAtOffset(new Pos(0, 0, -1));
        teleportPlayerAtOffset(new Pos(0, 0, 1));
        
    }
    
    private void teleportPlayerAtOffset(Pos offset) {
        Pos tempPos = getPos().copy();
        tempPos.add(offset);
        Entity tempEntity = App.world.getEntity(tempPos);
        if (tempEntity != null) {
            if (tempEntity instanceof Player) {
                Pos tempOffset = new Pos(
                        teleportRange - 2 * getRandom().nextInt(teleportRange),
                        teleportRange - 2 * getRandom().nextInt(teleportRange),
                        0
                );
                tempEntity.move(tempOffset);
            }
        }
    }
}
