/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.routes;

import com.mycompany.ostracraft.Account;
import com.mycompany.ostracraft.AccountDatabase;
import com.mycompany.ostracraft.App;
import spark.Request;
import spark.Response;
import spark.Route;

/**
 *
 * @author Jack
 */
public class CreateAccountRoute implements Route {
    
    private static String errorMessage1 = "Username should contain beween 1 and 30 characters.";
    private static String errorMessage2 = "Username has already been used.";
    private static String errorMessage3 = "Email address is not properly formatted.";
    
    public Object handle(Request request, Response response) {
        synchronized (App.world) {
            String tempName = request.queryParams("name");
            if (tempName.length() < 1 || tempName.length() > 30) {
                return errorMessage1;
            }
            Account tempAccount = AccountDatabase.database.getAccountByName(tempName);
            if (tempAccount != null) {
                return errorMessage2;
            }
            String tempEmail = request.queryParams("email");
            if (tempEmail.indexOf("@") < 0 || tempEmail.indexOf(".") < 0) {
                return errorMessage3;
            }
            String tempPasswordHash = request.queryParams("passwordHash");
            int tempId = AccountDatabase.database.getNextId();
            tempAccount = new Account(tempId, tempName, tempPasswordHash, tempEmail);
            AccountDatabase.database.addAccount(tempAccount);
            return "1";
        }
    }
    
}
