/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.routes;

import spark.Request;
import spark.Response;
import spark.Route;
import java.io.*;

/**
 *
 * @author Jack
 */
public class PageRoute implements Route {
    
    private String path;
    private boolean requiresLogin;
    private String contents;
    
    public PageRoute(String path, boolean requiresLogin) {
        this.path = path;
        this.requiresLogin = requiresLogin;
        
        StringBuilder tempBuilder = new StringBuilder();

        try {
            FileReader fileReader = new FileReader(path);

            BufferedReader bufferedReader = new BufferedReader(fileReader);

            while(true) {
                String tempLine = bufferedReader.readLine();
                if (tempLine == null) {
                    break;
                }
                tempBuilder.append(tempLine);
                tempBuilder.append('\n');
            }

            bufferedReader.close();         
        }
        catch(FileNotFoundException ex) {
            System.out.println("Unable to open file \"" + path + "\".");                
        }
        catch(IOException ex) {
            System.out.println("Error reading file \"" + path + "\".");
        }
        
        contents = tempBuilder.toString();
    }
    
    public Object handle(Request request, Response response) {
        if (requiresLogin && request.session().attribute("accountId") == null) {
            return "You must be logged in to view this page.";
        }
        return contents;
    }
}
