/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ostracraft.routes;

import com.mycompany.ostracraft.Account;
import com.mycompany.ostracraft.AccountDatabase;
import com.mycompany.ostracraft.App;
import com.mycompany.ostracraft.BlockTypeQuantityPair;
import com.mycompany.ostracraft.Inventory;
import com.mycompany.ostracraft.InventoryItem;
import com.mycompany.ostracraft.PlayerDatabase;
import com.mycompany.ostracraft.Pos;
import com.mycompany.ostracraft.Recipe;
import com.mycompany.ostracraft.StringEncoder;
import com.mycompany.ostracraft.World;
import com.mycompany.ostracraft.WorldUpdateCommandGenerator;
import com.mycompany.ostracraft.blocks.*;
import com.mycompany.ostracraft.entities.Entity;
import com.mycompany.ostracraft.entities.Player;
import java.util.ArrayList;
import java.util.List;
import spark.Request;
import spark.Response;
import spark.Route;

/**
 *
 * @author Jack
 */
public class WorldUpdateRoute implements Route {
    
	private static int maximumActionDistance = 5;
	
    public Object handle(Request request, Response response) {
        synchronized (App.world) {
            Integer tempInteger = request.session().attribute("accountId");
            if (tempInteger == null) {
                return "";
            }
            int tempAccountId = tempInteger.intValue();
            Player tempPlayer = App.world.getPlayerByAccountId(tempAccountId);
            if (tempPlayer == null) {
                tempPlayer = PlayerDatabase.database.loadPlayer(tempAccountId);
                App.world.addEntity(tempPlayer);
                // TEST CODE.
                /*
                Inventory tempInventory = tempPlayer.getInventory();
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), Gun.blockType.getId(), 0, 1));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), Bullet.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), CoalPowder.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), Switch.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), Wire.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), OrInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), AndInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), XorInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), SetInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), ResetInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), DataInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), ClockInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), ToggleInput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), FlipFlop.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), BufferOutput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), InvertingOutput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), DelayOutput.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), Led.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), Flower.blockType.getId(), 0, 999));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), DiamondTool.blockType.getId(), 0, 1));
                tempInventory.addInventoryItem(new InventoryItem(tempInventory.getNextInventoryItemId(), DiamondArmor.blockType.getId(), 0, 1));
                */
            }
            tempPlayer.activityUpdate();
            String[] tempCommandList = request.queryParams("commandList").split(";");
            boolean hasRetreivedBlocks = false;
            boolean isFirstOutputCommand = true;
            StringBuilder tempBuilder = new StringBuilder();
            int index = 0;
            while (index < tempCommandList.length) {
                String[] tempCommand = tempCommandList[index].split(",");
                int tempIndex = 0;
                while (tempIndex < tempCommand.length) {
                    String tempTerm = tempCommand[tempIndex];
                    tempTerm = StringEncoder.encoder.decode(tempTerm);
                    tempCommand[tempIndex] = tempTerm;
                    tempIndex += 1;
                }
                List<List<String>> tempResult = null;
                String tempCommandName = tempCommand[0];
                if (tempCommandName.equals("getBlocks") && !hasRetreivedBlocks) {
                    tempResult = getBlocksCommand(tempCommand, tempPlayer);
                    hasRetreivedBlocks = true;
                }
                if (tempCommandName.equals("pos")) {
                    tempResult = posCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("removeBlock")) {
                    tempResult = removeBlockCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("placeBlock")) {
                    tempResult = placeBlockCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("getInventory")) {
                    tempResult = getInventoryCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("craft")) {
                    tempResult = craftCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("walk")) {
                    tempResult = walkCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("wearArmor")) {
                    tempResult = wearArmorCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("removeArmor")) {
                    tempResult = removeArmorCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("attack")) {
                    tempResult = attackCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("eat")) {
                    tempResult = eatCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("interact")) {
                    tempResult = interactCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("fire")) {
                    tempResult = fireCommand(tempCommand, tempPlayer);
                }
                if (tempCommandName.equals("chat")) {
                    tempResult = chatCommand(tempCommand, tempPlayer);
                }
                if (tempResult != null)
                {
                    tempIndex = 0;
                    while (tempIndex < tempResult.size()) {
                        if (isFirstOutputCommand) {
                            isFirstOutputCommand = false;
                        } else {
                            tempBuilder.append(";");
                        }
                        List<String> tempOutputCommand = tempResult.get(tempIndex);
                        int tempIndex2 = 0;
                        while (tempIndex2 < tempOutputCommand.size()) {
                            String tempTerm = tempOutputCommand.get(tempIndex2);
                            tempTerm = StringEncoder.encoder.encode(tempTerm);
                            if (tempIndex2 > 0) {
                                tempBuilder.append(",");
                            }
                            tempBuilder.append(tempTerm);
                            tempIndex2 += 1;
                        }
                        tempIndex += 1;
                    }
                }
                index += 1;
            }
            return tempBuilder.toString();
        }
    }
    
    private List<List<String>> getBlocksCommand(String[] command, Player player) {
        List<List<String>> output = new ArrayList<List<String>>();
        Pos tempPos = new Pos(Integer.parseInt(command[1]), Integer.parseInt(command[2]), Integer.parseInt(command[3]));
        int tempWidth = Integer.parseInt(command[4]);
        int tempHeight = Integer.parseInt(command[5]);
        if (tempWidth > 40 || tempHeight > 10) {
        	return null;
        }
        Pos tempPos2 = tempPos.copy();
        tempPos2.setX(tempPos2.getX() + tempWidth / 2);
        tempPos2.setY(tempPos2.getY() + tempWidth / 2);
        tempPos2.setZ(tempPos2.getZ() + tempHeight / 2);
        if (player.getPos().getOrthogonalDistance(tempPos2) > maximumActionDistance) {
        	return null;
        }
        List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generateBlocksCommand(tempPos, tempWidth, tempHeight);
        output.add(tempOutputCommand);
        List<Entity> tempEntityList = App.world.getEntitiesInRegion(tempPos, tempWidth, tempHeight);
        tempOutputCommand = WorldUpdateCommandGenerator.generator.generateIsNightCommand();
        output.add(tempOutputCommand);
        double tempHealth = player.getHealth();
        tempOutputCommand = WorldUpdateCommandGenerator.generator.generateHealthCommand(tempHealth);
        output.add(tempOutputCommand);
        Inventory tempInventory = player.getInventory();
        if (player.getArmorHasChanged()) {
            if (tempInventory.getArmor() == null) {
                tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDeleteArmorCommand(tempInventory);
            } else {
                tempOutputCommand = WorldUpdateCommandGenerator.generator.generateUpdateArmorCommand(tempInventory);
            }
            output.add(tempOutputCommand);
            player.setArmorHasChanged(false);
        }
        if (tempInventory.getShouldSendToPlayer()) {
            output.addAll(WorldUpdateCommandGenerator.generator.generateRetrieveEntireInventoryCommand(tempInventory));
            tempInventory.setShouldSendToPlayer(false);
        }
        tempOutputCommand = WorldUpdateCommandGenerator.generator.generateOnlinePlayersCommand();
        output.add(tempOutputCommand);
        tempOutputCommand = WorldUpdateCommandGenerator.generator.generateChatCommand(player);
        if (tempOutputCommand != null) {
            output.add(tempOutputCommand);
        }
        int index = 0;
        while (index < tempEntityList.size()) {
            Entity tempEntity = tempEntityList.get(index);
            if (tempEntity.getId() != player.getId()) {
                tempOutputCommand = WorldUpdateCommandGenerator.generator.generateEntityCommand(tempEntity);
                output.add(tempOutputCommand);
            }
            index += 1;
        }
        return output;
    }
    
    private List<List<String>> posCommand(String[] command, Player player) {
        Pos tempPos = new Pos(Integer.parseInt(command[1]), Integer.parseInt(command[2]), Integer.parseInt(command[3]));
        if (!tempPos.equals(player.getPos())) {
            List<List<String>> output = new ArrayList<List<String>>();
            List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generatePosCommand(player.getPos());
            output.add(tempOutputCommand);
            return output;
        } else {
            return null;
        }
    }
    
    private List<List<String>> removeBlockCommand(String[] command, Player player) {
        Pos tempPos = new Pos(Integer.parseInt(command[1]), Integer.parseInt(command[2]), Integer.parseInt(command[3]));
        int tempInventoryItemId = Integer.parseInt(command[4]);
        if (player.getPos().getOrthogonalDistance(tempPos) > maximumActionDistance) {
        	return null;
        }
        BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.GENERATE_ENABLED);
        if (tempBlockType.getId() != Air.blockType.getId()) {
            Inventory tempInventory = player.getInventory();
            InventoryItem tempSelectedInventoryItem = tempInventory.getInventoryItemById(tempInventoryItemId);
            BlockType tempBlockType2;
            if (tempSelectedInventoryItem != null) {
                tempBlockType2 = tempSelectedInventoryItem.getBlockType();
            } else {
                tempBlockType2 = null;
            }
            if (!tempBlockType.canMineBlock(tempSelectedInventoryItem)) {
                return null;
            }
            double tempTime = tempBlockType.getMiningTime(tempBlockType2);
            player.useTime(tempTime * 0.75);
            if (player.isInTimeDebt()) {
                return null;
            }
            App.world.setBlockType(tempPos, Air.blockType, World.ChunkGenerationMode.GENERATE_ENABLED);
            List<BlockTypeQuantityPair> tempPairList = tempBlockType.getProducts(tempPos, tempSelectedInventoryItem);
            List<List<String>> output = new ArrayList<List<String>>();
            boolean tempResult = tempBlockType.damageInventoryItem(tempSelectedInventoryItem);
            if (tempResult) {
                List<String> tempOutputCommand;
                if (tempBlockType2.shouldRemoveFromInventory(tempSelectedInventoryItem.getBlockData())) {
                    tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDecreaseInventoryCommand(tempInventory, tempSelectedInventoryItem, 1);
                } else {
                    tempOutputCommand = WorldUpdateCommandGenerator.generator.generateUpdateInventoryDataCommand(tempSelectedInventoryItem);
                }
                output.add(tempOutputCommand);
            }
            int index = 0;
            while (index < tempPairList.size()) {
                BlockTypeQuantityPair tempPair = tempPairList.get(index);
                tempBlockType = tempPair.getBlockType();
                int tempBlockData = tempPair.getBlockData();
                int tempQuantity = tempPair.getQuantity();
                List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generateCreateOrIncreaseInventoryCommand(tempInventory, tempBlockType, tempBlockData, tempQuantity);
                output.add(tempOutputCommand);
                index += 1;
            }
            return output;
        } else {
            return null;
        }
    }
    
    private List<List<String>> placeBlockCommand(String[] command, Player player) {
        Pos tempPos = new Pos(Integer.parseInt(command[1]), Integer.parseInt(command[2]), Integer.parseInt(command[3]));
        if (player.getPos().getOrthogonalDistance(tempPos) > maximumActionDistance) {
        	return null;
        }
        BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.GENERATE_ENABLED);
        if (tempBlockType.getId() != Air.blockType.getId()) {
            return null;
        }
        int tempInventoryItemId = Integer.parseInt(command[4]);
        Inventory tempInventory = player.getInventory();
        InventoryItem tempInventoryItem = tempInventory.getInventoryItemById(tempInventoryItemId);
        if (tempInventoryItem == null) {
            return null;
        }
        int tempBlockId = tempInventoryItem.getBlockId();
        int tempBlockData = tempInventoryItem.getBlockData();
        tempBlockType = App.blockTypeSet.get(tempBlockId);
        App.world.setBlockType(tempPos, tempBlockType, World.ChunkGenerationMode.GENERATE_ENABLED);
        App.world.setBlockData(tempPos, tempBlockData, World.ChunkGenerationMode.GENERATE_ENABLED);
        List<List<String>> output = new ArrayList<List<String>>();
        List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDecreaseInventoryCommand(tempInventory, tempInventoryItem, 1);
        output.add(tempOutputCommand);
        return output;
    }
    
    private List<List<String>> getInventoryCommand(String[] command, Player player) {
        Inventory tempInventory = player.getInventory();
        return WorldUpdateCommandGenerator.generator.generateRetrieveEntireInventoryCommand(tempInventory);
    }
    
    private List<List<String>> craftCommand(String[] command, Player player) {
        Recipe tempRecipe = App.recipeSet.get(Integer.parseInt(command[1]));
        Inventory tempInventory = player.getInventory();
        if (!tempInventory.canCraftRecipe(tempRecipe)) {
            return null;
        }
        player.useTime(tempRecipe.getDuration() * 0.75);
        if (player.isInTimeDebt()) {
            return null;
        }
        List<List<String>> output = new ArrayList<List<String>>();     
        BlockTypeQuantityPair[] tempList = tempRecipe.getIngredientList();
        int index = 0;
        while (index < tempList.length) {
            BlockTypeQuantityPair tempPair = tempList[index];
            int tempQuantity = tempPair.getQuantity();
            InventoryItem tempInventoryItem = tempInventory.getInventoryItemByBlockId(tempPair.getBlockType().getId());
            List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDecreaseInventoryCommand(tempInventory, tempInventoryItem, tempQuantity);
            output.add(tempOutputCommand);
            index += 1;
        }
        BlockTypeQuantityPair tempPair = tempRecipe.getProduct();
        BlockType tempBlockType = tempPair.getBlockType();
        int tempBlockData = tempPair.getBlockData();
        int tempQuantity = tempPair.getQuantity();
        List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generateCreateOrIncreaseInventoryCommand(tempInventory, tempBlockType, tempBlockData, tempQuantity);
        output.add(tempOutputCommand);
        return output;
    }
    
    private List<List<String>> walkCommand(String[] command, Player player) {
        player.useTime(0.05);
        if (player.isInTimeDebt()) {
            return null;
        }
        Pos tempOffset = new Pos(Integer.parseInt(command[1]), Integer.parseInt(command[2]), Integer.parseInt(command[3]));
        if (Math.abs(tempOffset.getX()) > 1
        		|| Math.abs(tempOffset.getY()) > 1
        		|| tempOffset.getZ() != 0) {
        	return null;
        }
        player.walk(tempOffset);
        return null;
    }
    
    private List<List<String>> wearArmorCommand(String[] command, Player player) {
        int tempInventoryItemId = Integer.parseInt(command[1]);
        Inventory tempInventory = player.getInventory();
        InventoryItem tempInventoryItem = tempInventory.getInventoryItemById(tempInventoryItemId);
        if (tempInventoryItem == null) {
            return null;
        }
        if (!(tempInventoryItem.getBlockType() instanceof Armor)) {
            return null;
        }
        List<List<String>> output;
        output = WorldUpdateCommandGenerator.generator.generateCreateArmorCommand(tempInventory, tempInventoryItem);
        return output;
    }
    
    private List<List<String>> removeArmorCommand(String[] command, Player player) {
        Inventory tempInventory = player.getInventory();
        List<List<String>> output;
        output = WorldUpdateCommandGenerator.generator.generateRemoveArmorCommand(tempInventory);
        return output;
    }
    
    private List<List<String>> attackCommand(String[] command, Player player) {
        player.useTime(0.4);
        if (player.isInTimeDebt()) {
            return null;
        }
        int tempEntityId = Integer.parseInt(command[1]);
        int tempInventoryItemId = Integer.parseInt(command[2]);
        Entity tempEntity = App.world.getEntityById(tempEntityId);
        if (tempEntity == null) {
            return null;
        }
        Pos tempPos = tempEntity.getPos();
        if (player.getPos().getOrthogonalDistance(tempPos) > maximumActionDistance) {
        	return null;
        }
        Inventory tempInventory = player.getInventory();
        InventoryItem tempInventoryItem = tempInventory.getInventoryItemById(tempInventoryItemId);
        double tempDamage = player.getAttackDamage(tempInventoryItem);
        tempEntity.damage(tempDamage, player);
        boolean tempResult = tempEntity.damageInventoryItem(tempInventoryItem);
        if (tempResult) {
            if (tempResult) {
                BlockType tempBlockType = tempInventoryItem.getBlockType();
                List<List<String>> output = new ArrayList<List<String>>();
                List<String> tempOutputCommand;
                if (tempBlockType.shouldRemoveFromInventory(tempInventoryItem.getBlockData())) {
                    tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDecreaseInventoryCommand(tempInventory, tempInventoryItem, 1);
                } else {
                    tempOutputCommand = WorldUpdateCommandGenerator.generator.generateUpdateInventoryDataCommand(tempInventoryItem);
                }
                output.add(tempOutputCommand);
                return output;
            }
        }
        return null;
    }
    
    private List<List<String>> eatCommand(String[] command, Player player) {
        int tempInventoryItemId = Integer.parseInt(command[1]);
        Inventory tempInventory = player.getInventory();
        InventoryItem tempInventoryItem = tempInventory.getInventoryItemById(tempInventoryItemId);
        if (tempInventoryItem == null) {
            return null;
        }
        BlockType tempBlockType = tempInventoryItem.getBlockType();
        if (!(tempBlockType instanceof Food)) {
            return null;
        }
        Food tempFood = (Food)tempBlockType;
        double tempHealth = tempFood.getHealth();
        player.heal(tempHealth);
        List<List<String>> output = new ArrayList<List<String>>();
        List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDecreaseInventoryCommand(tempInventory, tempInventoryItem, 1);
        output.add(tempOutputCommand);
        return output;
    }
    
    private List<List<String>> interactCommand(String[] command, Player player) {
        Pos tempPos = new Pos(Integer.parseInt(command[1]), Integer.parseInt(command[2]), Integer.parseInt(command[3]));
        BlockType tempBlockType = App.world.getBlockType(tempPos, World.ChunkGenerationMode.GENERATE_ENABLED);
        tempBlockType.interact(tempPos);
        return null;
    }
    
    private List<List<String>> fireCommand(String[] command, Player player) {
        Pos tempPos = new Pos(Integer.parseInt(command[1]), Integer.parseInt(command[2]), Integer.parseInt(command[3]));
        int tempInventoryItemId = Integer.parseInt(command[4]);
        Pos tempOffset = new Pos(Integer.parseInt(command[5]), Integer.parseInt(command[6]), Integer.parseInt(command[7]));
        if (player.getPos().getOrthogonalDistance(tempPos) > maximumActionDistance) {
        	return null;
        }
        if (Math.abs(tempOffset.getX()) > 1
        		|| Math.abs(tempOffset.getY()) > 1
        		|| Math.abs(tempOffset.getZ()) > 1) {
        	return null;
        }
        Inventory tempInventory = player.getInventory();
        InventoryItem tempInventoryItem = tempInventory.getInventoryItemById(tempInventoryItemId);
        if (tempInventoryItem == null) {
            return null;
        }
        BlockType tempBlockType = tempInventoryItem.getBlockType();
        if (!(tempBlockType instanceof FirableBlock)) {
            return null;
        }
        FirableBlock tempFirableBlock = (FirableBlock)tempBlockType;
        BlockTypeQuantityPair[] tempList = tempFirableBlock.getFiringIngredients();
        int index = 0;
        while (index < tempList.length) {
            BlockTypeQuantityPair tempPair = tempList[index];
            int tempQuantity = tempPair.getQuantity();
            InventoryItem tempInventoryItem2 = tempInventory.getInventoryItemByBlockId(tempPair.getBlockType().getId());
            if (tempInventoryItem2 == null) {
                return null;
            }
            if (tempInventoryItem2.getQuantity() < tempQuantity) {
                return null;
            }
            index += 1;
        }
        List<List<String>> output = new ArrayList<List<String>>();
        index = 0;
        while (index < tempList.length) {
            BlockTypeQuantityPair tempPair = tempList[index];
            int tempQuantity = tempPair.getQuantity();
            InventoryItem tempInventoryItem2 = tempInventory.getInventoryItemByBlockId(tempPair.getBlockType().getId());
            List<String> tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDecreaseInventoryCommand(tempInventory, tempInventoryItem2, tempQuantity);
            output.add(tempOutputCommand);
            index += 1;
        }
        tempFirableBlock.fire(tempPos, tempOffset);
        tempInventoryItem.setBlockData(tempInventoryItem.getBlockData() + 1);
        List<String> tempOutputCommand;
        if (tempBlockType.shouldRemoveFromInventory(tempInventoryItem.getBlockData())) {
            tempOutputCommand = WorldUpdateCommandGenerator.generator.generateDecreaseInventoryCommand(tempInventory, tempInventoryItem, 1);
        } else {
            tempOutputCommand = WorldUpdateCommandGenerator.generator.generateUpdateInventoryDataCommand(tempInventoryItem);
        }
        output.add(tempOutputCommand);
        return output;
    }
    
    private List<List<String>> chatCommand(String[] command, Player player) {
        String tempMessage = player.getAccount().getName() + ": " + command[1];
        App.chatEngine.addMessage(tempMessage);
        return null;
    }
    
}
